/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#define VER     "0.1"


typedef unsigned char   u_char;


u_char *aftp_pwd(u_char *pwd);


int main(int argc, char *argv[]) {
    setbuf(stdout, NULL);

    fputs("\n"
        "Absolute FTP and SecureFX password decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 2) {
        printf("\nUsage: %s <password>\n"
            "\n"
            "The encoded passwords are stored in the binary files Absoluteftp.dat and\n"
            "SecureFX.dat, you must manually get the passwords from these files\n"
            "\n", argv[0]);
        exit(1);
    }

    printf("\nPassword:   %s\n\n",
        aftp_pwd(argv[1]));

    return(0);
}



u_char *aftp_pwd(u_char *pwd) {
    u_char  *ret;
    int     i,
            y,
            len;

    len = strlen(pwd) >> 1;
    ret = pwd;
    for(i = 0; i < len; i++) {
        sscanf(pwd, "%02x", &y);
        ret[i] = y;
        pwd += 2;
    }

    for(i = 4, y = 0; i < len; i++, y++) {
        ret[i] ^= ret[y & 3];
    }
    ret[i] = 0;
    return(ret + 4);
}

